
; neatl -- converts comments to lower case.  does not affect db strings
;	   or characters between 'ticks'.  insures all source code is
;	   upper-case.  this is called "the frank gaude' style".
; 	   by joe wright, to the public domain, 21 may 83.
;
; 06/01/83 modified and shortened some code.  reorganized the structure.
;	   you can name a destination file:
;
;	   b>neatu hello.asm newname.asm <cr>
;
;		which keeps the original file intact or:
;
;	   b>neatu hello.asm <cr>
;
;		renames the original to hello.bak and the new
;		file to the original name.
;
;					- irv hoff w6ffc
;
;***********************************************************************
;
; equates
;
ASCII	EQU	7FH		;scii mask
ASTER	EQU	2AH		;asterisk
CR	EQU	0DH
LF	EQU	0AH
LOCASE	EQU	20H		;lower case mask
SEMICOL	EQU	3BH		;semicolon
SPACE	EQU	20H
TICK	EQU	27H		;apostrophe
UPCASE	EQU	5FH		;upper case mask
;
;
	ORG	100H
;
;
;=======================================================================
;
; start - see if any source file mentioned, if not, display information
; telling how to use the program, then exit
;
START:	LXI	H,0
	DAD	SP		;get 'CCP' stack
	SHLD	STACK		;save it for exit
	LXI	SP,STACK	;set local stack
	LDA	FCB+1		;source file specified?
	CPI	SPACE
	LXI	D,INFO
	JZ	PRINTMSG	;if space, no file name mentioned
;
;
;=======================================================================
;
; see if any destination file mentioned, if not, copy source name as a
; default name
;
	LDA	FCB2+1		;destination file named?
	CPI	SPACE
	JNZ	START1		;if yes, exit
	LXI	H,FCB		;otherwise use same filename..	
	LXI	D,DEST		;..with .$$$ extent for now
	MVI	B,9
	CALL	MOVE
	JMP	START2
;
;
;=======================================================================
;
; move the destination filename into the special 'DEST' buffer
;
START1:	LXI	H,FCB2		;destination filename
	LXI	D,DEST		;destination 'FCP' in 'TPA'
	MVI	B,16		;number of bytes to move
	CALL	MOVE
;
;
;
;=======================================================================
;
; zero the record count (if still present)
;
START2:	XRA	A
	STA	SOURCE+32	;zero current record byte
	STA	DEST+32
;
;	
;=======================================================================
;
; open the source file, erase the destination file (in case one by that
; name) then open the destination file -- show error message if any of
; these cannot be accomplished.
;
	LXI	D,SOURCE	;fcb
	MVI	C,OPEN
	CALL	BDOS
	INR	A		;if error, 0ffh was returned
	JZ	NOSOURCE	;report error and exit
;
	LXI	D,DEST		;fcb
	MVI	C,DELETE	;delete existing file
	CALL	BDOS
	LXI	D,DEST
	MVI	C,MAKE
	CALL	BDOS
	INR	A		;if error, 0ffh was returned
	JZ	NODIR		;no directory space. report and exit
;
;
;=======================================================================
;
; now transfer the source file (or the first 32k) into the buffer
;
NEXT:	LXI	H,BUFFER
;
NEXT1:	XCHG			;sector address to 'DE'
	PUSH	D		;save dmadr
	MVI	C,SETDMA
	CALL	BDOS
	LXI	D,SOURCE
	MVI	C,READ
	CALL	BDOS
	ORA	A
	JNZ	EOF		;end of file
;
	LDA	COUNT		;count is zero initially (mod 256)
	INR	A
	STA	COUNT		;can go up to 256 (32k)
	POP	H		;get dmadr back
	LXI	D,128		;bump it by one sector
	DAD	D
	JNZ	NEXT1		;read 256 (32k) sectors or until 'EOF'
;
;
;=======================================================================
;
; go through the buffer.  change any comments to lower-case, all source
; source code to upper-case (but leave any db strings as they were).
;
FILTER:	LXI	H,BUFFER
;
FILT1:	MOV	A,M		;get the character
	ANI	ASCII
	MOV	B,A		;save the character
	CPI	CR
	JZ	RSFLG
	CPI	SPACE
	JC	CTL1
;
	CPI	ASTER		;comment area?  (asterisk)
	JZ	STFLG
;
	CPI	SEMICOL		;comment area?  (semicolon)
	JZ	STFLG1
	STA	CTLFLG		;show no longer in 1st column
;
	CPI	TICK		;db area?
	JZ	TKCHK		;if yes, go set the flag
;
	LDA	OKFLG		;check "ok-now" flag
	ORA	A
	MOV	A,B
	JNZ	CTL		;if set, "ok-now" (leave alone)
;
	LDA	SCFLG		;check semicolon flag
	ORA	A
	MOV	A,B
	JNZ	LOW1		;if set, put everything lower-case
;
	CPI	61H		;lower case alpha?
	JC	CTL		;if less, exit
	CPI	7AH+1
	JNC	CTL		;if more, exit
	ANI	UPCASE		;otherwise change to upper-case
;
CTL:	MOV	M,A		;store
;
CTL1:	INX	H
	PUSH	H		;save it for a moment
	LXI	D,-(BUFFER+8000H)  ;end of buffer
	DAD	D
	JC	WRIT
	POP	H		;restore 'HL'
	JMP	FILT1
;.....
;
;
LOW1:	CPI	41H
	JC	CTL
	CPI	5AH+1
	JNC	CTL
	ORI	LOCASE
	JMP	CTL
;.....
;
;
;=======================================================================
;
; when finished (or at top of buffer) write to disk
;
WRIT:	LXI	H,BUFFER	;start of buffer
;
WRIT1:	XCHG			;current sector address to 'DE'
	PUSH	D		;save buffer start for now
	MVI	C,SETDMA	;will be getting data from this area	
	CALL	BDOS
;
	LXI	D,DEST		;destination file name
	MVI	C,WRITE		;put buffer contents into that file
	CALL	BDOS
;
	ORA	A		;returns with non-zero if disk is full
	JNZ	WRITERR
;
	LDA	COUNT		;get sector count
	DCR	A		;one less to go
	STA	COUNT
	JZ	WREOF		;done when sector count is zero
;
	POP	H		;get start of current sector back
	LXI	D,128
	DAD	D		;add address for next sector
	JMP	WRIT1		;go again
;.....
;
;
;=======================================================================
;
; rename both files if no destination file name was specified
;
NUNAME:	LDA	DEST+9		;1st character in .ext
	CPI	'$'		;see if using the default name
	JNZ	EXIT		;if not, keep things as they are
;
	LXI	H,FCB		;move original name including extent
	LXI	D,ONAME
	MVI	B,16
	CALL	MOVE
;
	LXI	H,FCB+1		;move it again but skip extent
	LXI	D,ONAME+17
	MVI	B,8
	CALL	MOVE
;
	LXI	D,ONAME
	MVI	C,RENAME
	CALL	BDOS
;
;
; now rename the new file
;
	LXI	H,FCB+1
	LXI	D,DEST+17
	MVI	B,16
	CALL	MOVE
;
	LXI	D,DEST
	MVI	C,RENAME
	CALL	BDOS
	JMP	EXIT
;.....
;
;
;=======================================================================
;
; utilty routines and error messages
;
EOF:	MVI	A,1
	STA	EOFLG
	JMP	FILTER
;.....
;
;
EXIT:	LHLD	STACK		;get 'CCP' stack return address
	SPHL
	RET			;return to cpm
;.....
;
;
MOVE:	MOV	A,M
	STAX	D
	INX	H
	INX	D
	DCR	B		;decrement byte count
	JNZ	MOVE		;if not zero, move another byte
	RET
;.....
;
;
NODIR:	LXI	D,NDIR
	JMP	PRINTMSG
;.....
;
;
NOCLOSE:
	LXI	D,NCLOS
	JMP	PRINTMSG
;.....
;
;
NOSOURCE:
	LXI	D,NSRC
	JMP	PRINTMSG
;.....
;
;
PRINTMSG:
	PUSH	D
	LXI	D,CRLF
	CALL	PRINT1
	POP	D
	CALL	PRINT1
	LXI	D,CRLF
	CALL	PRINT1
	JMP	EXIT
;
PRINT1:	MVI	C,PRINT
	JMP	BDOS
;.....
;
;
RSFLG:	XRA	A
	STA	CTLFLG
	STA	OKFLG
	STA	SCFLG
	JMP	CTL1
;.....
;
;
STFLG:	LDA	CTLFLG		;control-flag still set to zero?
	ORA	A
	JNZ	CTL1		;if not, not in 1st column, ignore
;
STFLG1:	MVI	A,1
	STA	CTLFLG
	STA	SCFLG		;set semicolon flag
	JMP	CTL1
;.....
;
;
TKCHK:	LDA	OKFLG
	CMA
	STA	OKFLG
	JMP	CTL1
;.....
;
;
WREOF:	LDA	EOFLG
	ORA	A
	JZ	NEXT
;
	LXI	D,DEST		;if end of file, close destination file
	MVI	C,CLOSE
	CALL	BDOS
	INR	A		;0ffh means an error
	JZ	NOCLOSE
	JMP	NUNAME
;.....
;
;
WRITERR:
	LXI	D,WRER
	JMP	PRINTMSG
;.....
;
;
;=======================================================================
;
; messages
;
CRLF	DB	CR,LF,'$'
NDIR:	DB	'   No Directory Space Remains',CR,LF,'$'
NSRC:	DB	'   No Source File$'
WRER:	DB	'   Write Error, Disk is Full$'
NCLOS:	DB	'   Cannot Close Destination File, Directory full$'
INFO:	DB	'Usage: NEATU will read a SOURCE.ASM, create a DEST.ASM'
	DB	CR,LF,'       converting commands and comments to '
	DB	'lower case',CR,LF,'       without affecting strings '
	DB	'between ''ticks''.',CR,LF,LF
	DB	'Form:  B>NEATU SOURCE.ASM DEST.ASM <cr>',CR,LF
	DB	'           which keeps the original file intact or:'
	DB	CR,LF,'       B>NEATU HELLO.ASM <cr>',CR,LF
	DB	'           renames the original file to HELLO.BAK'
	DB	CR,LF,'           and the new file to the original '
	DB	'name.','$'
COUNT:	DB	0
CTLFLG: DB	0
EOFLG:	DB	0
OKFLG:	DB	0
SCFLG:	DB	0
DEST:	DB	0,'        $$$',0,0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0,0
ONAME:	DB	0,'           ',0,0,0,0,0,'        BAK',0,0,0,0
	DS	32		;stack space
BUFFER:	EQU	($+255)/256*256	;page boundary
STACK:	EQU	BUFFER-2
;.....
;
;
; system equates
;
BDOS	EQU	0005H
PRINT	EQU	9
OPEN	EQU	15
DELETE	EQU	19
MAKE	EQU	22
RENAME	EQU	23
SETDMA	EQU	26
READ	EQU	20
WRITE	EQU	21
CLOSE	EQU	16
FCB	EQU	5CH		;default file control block
FCB2	EQU	6CH		;second default fcb
SOURCE	EQU	FCB
;.....
;
;
	END	START
